// MX_I2CUtilDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MX_I2CUtil.h"
#include "MX_I2CUtilDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMX_I2CUtilDlg dialog




CMX_I2CUtilDlg::CMX_I2CUtilDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMX_I2CUtilDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMX_I2CUtilDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMX_I2CUtilDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_WRITE, &CMX_I2CUtilDlg::OnBnClickedWrite)
	ON_BN_CLICKED(IDC_READ, &CMX_I2CUtilDlg::OnBnClickedRead)
	ON_BN_CLICKED(IDC_READ_GPIO, &CMX_I2CUtilDlg::OnBnClickedReadGpio)
	ON_BN_CLICKED(IDC_CLEAR, &CMX_I2CUtilDlg::OnBnClickedClear)
	ON_BN_CLICKED(IDOK, &CMX_I2CUtilDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CMX_I2CUtilDlg message handlers

BOOL CMX_I2CUtilDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	if (!m_VenCmd.IsLoaded())
	{
		if (!m_VenCmd.Load())
		{
			CString szMsg;
			szMsg.LoadString(IDS_STRING_LOAD_FAIL);
			AfxMessageBox(szMsg);
			OnBnClickedOk();
		}
	}
	SetDlgItemText(IDC_EDIT_ADDR,L"98");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMX_I2CUtilDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMX_I2CUtilDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CMX_I2CUtilDlg::OnBnClickedWrite()
{
	CString szItem;
	DWORD dwAddr, dwSubAddr;
	ULONG ulLen;

	GetDlgItemText(IDC_EDIT_ADDR,szItem);
	dwAddr		= (DWORD)m_VenCmd.ConvertHexByteStrToHex(szItem.GetBuffer(0));
	GetDlgItemText(IDC_EDIT_SUBADDR,szItem);
	dwSubAddr	= (DWORD)m_VenCmd.ConvertHexByteStrToHex(szItem.GetBuffer(0));
	ulLen		= (ULONG)GetDlgItemInt(IDC_EDIT_LENGTH);

	BYTE  iData[10];
	if (ulLen > 10)
		ulLen = 10;
	for (int i = 0; i < ulLen; i ++)
	{
		CString szItem;
		GetDlgItemText(IDC_EDIT_DATA1 + i,szItem);
		iData[i] = m_VenCmd.ConvertHexByteStrToHex(szItem.GetBuffer(0));
	}
	m_VenCmd.MX_WriteI2C(dwAddr,dwSubAddr,iData,ulLen);
}

void CMX_I2CUtilDlg::OnBnClickedRead()
{
	CString szItem;
	DWORD dwAddr, dwSubAddr;
	ULONG ulLen;

	GetDlgItemText(IDC_EDIT_ADDR,szItem);
	dwAddr		= (DWORD)m_VenCmd.ConvertHexByteStrToHex(szItem.GetBuffer(0));
	GetDlgItemText(IDC_EDIT_SUBADDR,szItem);
	dwSubAddr	= (DWORD)m_VenCmd.ConvertHexByteStrToHex(szItem.GetBuffer(0));
	ulLen		= (ULONG)GetDlgItemInt(IDC_EDIT_LENGTH);

	BYTE  iData[10];
	if (ulLen > 10)
		ulLen = 10;
	m_VenCmd.MX_ReadI2C(dwAddr,dwSubAddr,iData,ulLen);
	for (int i = 0; i < ulLen; i ++)
	{
		CString szText;
		szText.Format(L"%02x",iData[i]);
		SetDlgItemText(IDC_EDIT_DATA1 + i,szText.GetBuffer(0));
	}
}

void CMX_I2CUtilDlg::OnBnClickedReadGpio()
{
	// TODO: Add your control notification handler code here
}

void CMX_I2CUtilDlg::OnBnClickedClear()
{
	CString szBlank = L" ";
	SetDlgItemText(IDC_EDIT_ADDR,szBlank);
	SetDlgItemText(IDC_EDIT_SUBADDR,szBlank);
	SetDlgItemText(IDC_EDIT_LENGTH,szBlank);
	for (int i = 0; i < 10; i ++)
		SetDlgItemText(IDC_EDIT_DATA1 + i,L" ");
}

void CMX_I2CUtilDlg::OnBnClickedOk()
{
	if (!m_VenCmd.IsLoaded())
		m_VenCmd.Unload();
	OnOK();
}
